from osgeo.ogr import Geometry


class BuildMultiPolygon:
    def __init__(self):
        self.__stack_polygons=[]
    def add(self,geometry:Geometry):
        if len(self.__stack_polygons)==0:
            self.__stack_polygons.append(geometry)
            return
        self.is_contain = False
        area_curent=geometry.Area()
        for i,geo in enumerate(self.__stack_polygons):
            self.is_contain=False
            area_base=geo.Area()
            if geo.Intersects(geometry) :
                self.is_contain=True
            else:
                if geo.Contains(geometry):
                    self.is_contain=True
            if self.is_contain:
                if area_curent>area_base:
                    geo_diff=geometry.Difference(geo)
                else:
                    geo_diff=geo.Difference(geometry)
                self.__stack_polygons[i]=geo_diff
                break
        if not self.is_contain:
            self.__stack_polygons.append(geometry)
    def getPolygons(self):
        return self.preparePolygons(self.__stack_polygons)
    def get_temp_polygons(self):
        return self.__stack_polygons
    def clear(self):
        for i in len(self.__stack_polygons):
            self.__stack_polygons[i]=None
        self.__stack_polygons=[]

    def preparePolygons(self,polygons):

        temp_polygons=polygons
        while True:
            temp_polygons,is_contain=self.__recursPoly(temp_polygons)
            if not is_contain:
                break
        return temp_polygons
    def __recursPoly(self,polygons):
        temp_cls=BuildMultiPolygon()
        for geo in polygons:
            if geo is None:
                continue
            temp_cls.add(geo)

        return temp_cls.get_temp_polygons(),temp_cls.is_contain






